\section{Introduction}

The aim of this project was to implement a multi-mobile robot system with a
centralized
controller~\cite{Roszkowska:Jakubiak:CsMMRS:2021,Roszkowska:Makowski:Janiec:MlCMMRS:2023}.
The system includes a multiple autonomous mobile robots that can move in a
virtual environment. The movement of the robots is controlled by a centralized
controller in order to avoid collisions and to accomplish missions.

There are two main reasons why this project was chosen. Firstly, the project
allows to learn the basics of ROS2 framework~\cite{ROS2:2022} and Gazebo
simulator~\cite{Gazebo:2014}. Secondly, the project is a good starting point
for further development of the multi-robot systems, in example, studies for
master thesis.

The robots in the system are controlled by the Nav2
stack~\cite{Rak:2022:TB2_Nav2}. The Nav2 stack is a navigation system for ROS2
framework. It is a modular, portable and general-purpose toolbox for robot
navigation. The Nav2 stack is a successor of the ROS Navigation Stack.

The mobile robots are controlled by the centralized controller. The controller
is implemented as a multiple ROS2 nodes. The controller is responsible for
dividing the paths for the robots and for avoiding collisions. The controller
uses the ROS2 action clients and services to communicate with the Nav2 stack.
Additionally, the controller implements a map server node that is responsible
for loading the map of the environment.

The diagram of the system is presented in Figure~\ref{fig:system-diagram}.
\begin{figure}[!hptb]
    \centering
    \includegraphics[width=0.8\textwidth]{images/system-diagram.pdf}
    \caption{Diagram of the system}%
    \label{fig:system-diagram}
\end{figure}